
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega32U4
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 640 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega32U4
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2560
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU WDTCSR=0x60
	.EQU UCSR1A=0xC8
	.EQU UDR1=0xCE
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x0AFF
	.EQU __DSTACK_SIZE=0x0280
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	CALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _tik=R3
	.DEF _tik_msb=R4
	.DEF _tim=R5
	.DEF _tim_msb=R6
	.DEF _pusb_config=R7
	.DEF _pusb_config_msb=R8

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usb_general_isr
	JMP  _usb_endpoint_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_usb_config:
	.DB  0x3,0x1,LOW(_usb_keyboard),HIGH(_usb_keyboard),0x8,0x33,0x8,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,LOW(_usb_descriptor_list*2),HIGH(_usb_descriptor_list*2),0x8,0x64,0xFA
_usb_device_descriptor:
	.DB  0x12,0x1,0x0,0x2,0x0,0x0,0x0,0x20
	.DB  0xEB,0x3,0x10,0x31,0x11,0x3,0x1,0x2
	.DB  0x3,0x1
_hid_keyboard_report_descriptor:
	.DB  0x5,0x1,0x9,0x6,0xA1,0x1,0x75,0x1
	.DB  0x95,0x8,0x5,0x7,0x19,0xE0,0x29,0xE7
	.DB  0x15,0x0,0x25,0x1,0x81,0x2,0x95,0x1
	.DB  0x75,0x8,0x81,0x3,0x95,0x5,0x75,0x1
	.DB  0x5,0x8,0x19,0x1,0x29,0x5,0x91,0x2
	.DB  0x95,0x1,0x75,0x3,0x91,0x3,0x95,0x6
	.DB  0x75,0x8,0x15,0x0,0x25,0xFF,0x5,0x7
	.DB  0x19,0x0,0x29,0xFF,0x81,0x0,0xC0
_usb_string0:
	.DB  0x4,0x3,0x9,0x4
_usb_string1:
	.DB  0x26,0x3,0x48,0x0,0x50,0x0,0x20,0x0
	.DB  0x49,0x0,0x6E,0x0,0x66,0x0,0x6F,0x0
	.DB  0x54,0x0,0x65,0x0,0x63,0x0,0x68,0x0
	.DB  0x20,0x0,0x53,0x0,0x2E,0x0,0x52,0x0
	.DB  0x2E,0x0,0x4C,0x0,0x2E,0x0
_usb_string2:
	.DB  0x32,0x3,0x43,0x0,0x6F,0x0,0x64,0x0
	.DB  0x65,0x0,0x56,0x0,0x69,0x0,0x73,0x0
	.DB  0x69,0x0,0x6F,0x0,0x6E,0x0,0x41,0x0
	.DB  0x56,0x0,0x52,0x0,0x20,0x0,0x55,0x0
	.DB  0x53,0x0,0x42,0x0,0x20,0x0,0x44,0x0
	.DB  0x65,0x0,0x76,0x0,0x69,0x0,0x63,0x0
	.DB  0x65,0x0
_usb_string3:
	.DB  0xC,0x3,0x30,0x0,0x30,0x0,0x30,0x0
	.DB  0x30,0x0,0x31,0x0
_usb_config_descriptor:
	.DB  0x9,0x2,0x22,0x0,0x1,0x1,0x0,0xC0
	.DB  0x32,0x9,0x4,0x0,0x0,0x1,0x3,0x1
	.DB  0x1,0x0,0x9,0x21,0x11,0x1,0x0,0x1
	.DB  0x22,0x3F,0x0,0x7,0x5,0x83,0x3,0x8
	.DB  0x0,0x5
_usb_descriptor_list:
	.DB  0x0,0x1,0x0,0x0,LOW(_usb_device_descriptor*2),HIGH(_usb_device_descriptor*2),0x12,0x0
	.DB  0x2,0x0,0x0,LOW(_usb_config_descriptor*2),HIGH(_usb_config_descriptor*2),0x22,0x0,0x21
	.DB  0x0,0x0,LOW(_usb_config_descriptor*2+18),HIGH(_usb_config_descriptor*2+18),0x9,0x0,0x22,0x0
	.DB  0x0,LOW(_hid_keyboard_report_descriptor*2),HIGH(_hid_keyboard_report_descriptor*2),0x3F,0x0,0x3,0x0,0x0
	.DB  LOW(_usb_string0*2),HIGH(_usb_string0*2),0x4,0x1,0x3,0x9,0x4,LOW(_usb_string1*2)
	.DB  HIGH(_usb_string1*2),0x26,0x2,0x3,0x9,0x4,LOW(_usb_string2*2),HIGH(_usb_string2*2)
	.DB  0x32,0x3,0x3,0x9,0x4,LOW(_usb_string3*2),HIGH(_usb_string3*2),0xC

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x0,0x0,0x0,0x0
	.DB  0x0,0x0


__GLOBAL_INI_TBL:
	.DW  0x06
	.DW  0x03
	.DW  __REG_VARS*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x380

	.CSEG
;/*******************************************************
;This program was created by the
;CodeWizardAVR V3.12 Advanced
;Automatic Program Generator
; Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 27.06.2019
;Author  :
;Company :
;Comments:
;
;
;Chip type               : ATmega32U4
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 640
;*******************************************************/
;
;#include <mega32u4.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
     .EQU __sm_adc_noise_red=0x02 // 26022010_1
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;#include <delay.h>
;// USB Device functions
;#include <usb_device.h>
;// USB Human Interface Device functions
;#include <usb_hid.h>
;// USB initialization
;#include "usb_init.h"
;
;#define KEY_EN PINF.6
;#define KEY_BK PINF.7
;#define KEY_CP PINF.4
;#define KEY_PS PINF.5
;#define JP_TM  PIND.1
;
;unsigned int tik=0;
;unsigned int tim=0;
;
;void pr()
; 0000 002B {

	.CSEG
_pr:
; .FSTART _pr
; 0000 002C 
; 0000 002D   if(tik<tim)
	__CPWRR 3,4,5,6
	BRSH _0x3
; 0000 002E   {
; 0000 002F    tik++;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 3,4,30,31
; 0000 0030    if(tik==tim-1)
	__GETW1R 5,6
	SBIW R30,1
	CP   R30,R3
	CPC  R31,R4
	BRNE _0x4
; 0000 0031    {
; 0000 0032     usb_keyboard_keypress(KS_F1,0);
	LDI  R30,LOW(58)
	CALL SUBOPT_0x0
; 0000 0033     PORTB.0=1;
	SBI  0x5,0
; 0000 0034     PORTD.5=1;
	SBI  0xB,5
; 0000 0035    }
; 0000 0036 
; 0000 0037   }
_0x4:
; 0000 0038 
; 0000 0039   delay_ms(100);
_0x3:
	CALL SUBOPT_0x1
; 0000 003A 
; 0000 003B   if(KEY_CP==0)
	SBIC 0xF,4
	RJMP _0x9
; 0000 003C   {
; 0000 003D    delay_ms(100);
	CALL SUBOPT_0x1
; 0000 003E    while(!KEY_CP){;};
_0xA:
	SBIS 0xF,4
	RJMP _0xA
; 0000 003F    usb_keyboard_keypress(KS_I,0); usb_keyboard_keypress(KS_F,0);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x0
	LDI  R30,LOW(9)
	CALL SUBOPT_0x0
; 0000 0040   }
; 0000 0041 
; 0000 0042     if(KEY_PS==0)
_0x9:
	SBIC 0xF,5
	RJMP _0xD
; 0000 0043   {
; 0000 0044    delay_ms(100);
	CALL SUBOPT_0x1
; 0000 0045    while(!KEY_PS){;};
_0xE:
	SBIS 0xF,5
	RJMP _0xE
; 0000 0046    usb_keyboard_keypress(KS_V,0); usb_keyboard_keypress(KS_O,0);
	LDI  R30,LOW(25)
	CALL SUBOPT_0x0
	LDI  R30,LOW(18)
	CALL SUBOPT_0x0
; 0000 0047    usb_keyboard_keypress(KS_I,0); usb_keyboard_keypress(KS_D,0);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x0
	LDI  R30,LOW(7)
	CALL SUBOPT_0x0
; 0000 0048   }
; 0000 0049 
; 0000 004A       if(KEY_BK==0)
_0xD:
	SBIC 0xF,7
	RJMP _0x11
; 0000 004B   {
; 0000 004C    delay_ms(100);
	CALL SUBOPT_0x1
; 0000 004D    while(!KEY_BK){;};
_0x12:
	SBIS 0xF,7
	RJMP _0x12
; 0000 004E     usb_keyboard_keypress(KS_W,0); usb_keyboard_keypress(KS_H,0);
	LDI  R30,LOW(26)
	CALL SUBOPT_0x0
	LDI  R30,LOW(11)
	CALL SUBOPT_0x0
; 0000 004F    usb_keyboard_keypress(KS_I,0); usb_keyboard_keypress(KS_L,0);
	LDI  R30,LOW(12)
	CALL SUBOPT_0x0
	LDI  R30,LOW(15)
	CALL SUBOPT_0x0
; 0000 0050    usb_keyboard_keypress(KS_E,0);
	LDI  R30,LOW(8)
	CALL SUBOPT_0x0
; 0000 0051   }
; 0000 0052 
; 0000 0053        if(KEY_EN==0)
_0x11:
	SBIC 0xF,6
	RJMP _0x15
; 0000 0054   {
; 0000 0055    delay_ms(100);
	CALL SUBOPT_0x1
; 0000 0056    while(!KEY_EN){;};
_0x16:
	SBIS 0xF,6
	RJMP _0x16
; 0000 0057    usb_keyboard_keypress(KS_F,0); usb_keyboard_keypress(KS_O,0);
	LDI  R30,LOW(9)
	CALL SUBOPT_0x0
	LDI  R30,LOW(18)
	CALL SUBOPT_0x0
; 0000 0058    usb_keyboard_keypress(KS_R,0);
	LDI  R30,LOW(21)
	CALL SUBOPT_0x0
; 0000 0059   }
; 0000 005A 
; 0000 005B }
_0x15:
	RET
; .FEND
;
;void main(void)
; 0000 005E {
_main:
; .FSTART _main
; 0000 005F // Crystal Oscillator division factor: 1
; 0000 0060 #pragma optsize-
; 0000 0061 CLKPR=(1<<CLKPCE);
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 0062 CLKPR=(0<<CLKPCE) | (0<<CLKPS3) | (0<<CLKPS2) | (0<<CLKPS1) | (0<<CLKPS0);
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 0063 #ifdef _OPTIMIZE_SIZE_
; 0000 0064 #pragma optsize+
; 0000 0065 #endif
; 0000 0066 
; 0000 0067 // Input/Output Ports initialization
; 0000 0068 // Port B initialization
; 0000 0069 DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (0<<DDB2) | (0<<DDB1) | (1<<DDB0);
	LDI  R30,LOW(1)
	OUT  0x4,R30
; 0000 006A PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);
	LDI  R30,LOW(0)
	OUT  0x5,R30
; 0000 006B 
; 0000 006C // Port C initialization
; 0000 006D // Function: Bit7=In Bit6=In
; 0000 006E DDRC=(0<<DDC7) | (0<<DDC6);
	OUT  0x7,R30
; 0000 006F PORTC=(0<<PORTC7) | (0<<PORTC6);
	OUT  0x8,R30
; 0000 0070 
; 0000 0071 // Port D initialization
; 0000 0072 DDRD=(0<<DDD7) | (0<<DDD6) | (1<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
	LDI  R30,LOW(32)
	OUT  0xA,R30
; 0000 0073 PORTD=(0<<PORTD7) | (0<<PORTD6) | (1<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (1<<PORTD1) | (0<<PORTD0);
	LDI  R30,LOW(34)
	OUT  0xB,R30
; 0000 0074 
; 0000 0075 // Port E initialization
; 0000 0076 // Function: Bit6=In Bit2=In
; 0000 0077 DDRE=(0<<DDE6) | (0<<DDE2);
	LDI  R30,LOW(0)
	OUT  0xD,R30
; 0000 0078 PORTE=(0<<PORTE6) | (0<<PORTE2);
	OUT  0xE,R30
; 0000 0079 
; 0000 007A // Port F initialization
; 0000 007B DDRF=(0<<DDF7) | (0<<DDF6) | (0<<DDF5) | (0<<DDF4) | (0<<DDF1) | (0<<DDF0);
	OUT  0x10,R30
; 0000 007C PORTF=(1<<PORTF7) | (1<<PORTF6) | (1<<PORTF5) | (1<<PORTF4) | (0<<PORTF1) | (0<<PORTF0);
	LDI  R30,LOW(240)
	OUT  0x11,R30
; 0000 007D 
; 0000 007E // Timer/Counter 0 initialization
; 0000 007F // Clock source: System Clock
; 0000 0080 // Clock value: Timer 0 Stopped
; 0000 0081 // Mode: Normal top=0xFF
; 0000 0082 // OC0A output: Disconnected
; 0000 0083 // OC0B output: Disconnected
; 0000 0084 TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (0<<COM0B1) | (0<<COM0B0) | (0<<WGM01) | (0<<WGM00);
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0085 TCCR0B=(0<<WGM02) | (0<<CS02) | (0<<CS01) | (0<<CS00);
	OUT  0x25,R30
; 0000 0086 TCNT0=0x00;
	OUT  0x26,R30
; 0000 0087 OCR0A=0x00;
	OUT  0x27,R30
; 0000 0088 OCR0B=0x00;
	OUT  0x28,R30
; 0000 0089 
; 0000 008A // Timer/Counter 1 initialization
; 0000 008B // Clock source: System Clock
; 0000 008C // Clock value: Timer1 Stopped
; 0000 008D // Mode: Normal top=0xFFFF
; 0000 008E // OC1A output: Disconnected
; 0000 008F // OC1B output: Disconnected
; 0000 0090 // OC1C output: Disconnected
; 0000 0091 // Noise Canceler: Off
; 0000 0092 // Input Capture on Falling Edge
; 0000 0093 // Timer1 Overflow Interrupt: Off
; 0000 0094 // Input Capture Interrupt: Off
; 0000 0095 // Compare A Match Interrupt: Off
; 0000 0096 // Compare B Match Interrupt: Off
; 0000 0097 // Compare C Match Interrupt: Off
; 0000 0098 TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<COM1C1) | (0<<COM1C0) | (0<<WGM11) | (0<<WGM10);
	STS  128,R30
; 0000 0099 TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (0<<CS10);
	STS  129,R30
; 0000 009A TCNT1H=0x00;
	STS  133,R30
; 0000 009B TCNT1L=0x00;
	STS  132,R30
; 0000 009C ICR1H=0x00;
	STS  135,R30
; 0000 009D ICR1L=0x00;
	STS  134,R30
; 0000 009E OCR1AH=0x00;
	STS  137,R30
; 0000 009F OCR1AL=0x00;
	STS  136,R30
; 0000 00A0 OCR1BH=0x00;
	STS  139,R30
; 0000 00A1 OCR1BL=0x00;
	STS  138,R30
; 0000 00A2 OCR1CH=0x00;
	STS  141,R30
; 0000 00A3 OCR1CL=0x00;
	STS  140,R30
; 0000 00A4 
; 0000 00A5 // Timer/Counter 3 initialization
; 0000 00A6 // Clock source: System Clock
; 0000 00A7 // Clock value: Timer3 Stopped
; 0000 00A8 // Mode: Normal top=0xFFFF
; 0000 00A9 // OC3A output: Disconnected
; 0000 00AA // OC3B output: Disconnected
; 0000 00AB // OC3C output: Disconnected
; 0000 00AC // Noise Canceler: Off
; 0000 00AD // Input Capture on Falling Edge
; 0000 00AE // Timer3 Overflow Interrupt: Off
; 0000 00AF // Input Capture Interrupt: Off
; 0000 00B0 // Compare A Match Interrupt: Off
; 0000 00B1 // Compare B Match Interrupt: Off
; 0000 00B2 // Compare C Match Interrupt: Off
; 0000 00B3 TCCR3A=(0<<COM3A1) | (0<<COM3A0) | (0<<COM3B1) | (0<<COM3B0) | (0<<COM3C1) | (0<<COM3C0) | (0<<WGM31) | (0<<WGM30);
	STS  144,R30
; 0000 00B4 TCCR3B=(0<<ICNC3) | (0<<ICES3) | (0<<WGM33) | (0<<WGM32) | (0<<CS32) | (0<<CS31) | (0<<CS30);
	STS  145,R30
; 0000 00B5 TCNT3H=0x00;
	STS  149,R30
; 0000 00B6 TCNT3L=0x00;
	STS  148,R30
; 0000 00B7 ICR3H=0x00;
	STS  151,R30
; 0000 00B8 ICR3L=0x00;
	STS  150,R30
; 0000 00B9 OCR3AH=0x00;
	STS  153,R30
; 0000 00BA OCR3AL=0x00;
	STS  152,R30
; 0000 00BB OCR3BH=0x00;
	STS  155,R30
; 0000 00BC OCR3BL=0x00;
	STS  154,R30
; 0000 00BD OCR3CH=0x00;
	STS  157,R30
; 0000 00BE OCR3CL=0x00;
	STS  156,R30
; 0000 00BF 
; 0000 00C0 // Timer/Counter 4 initialization
; 0000 00C1 // Clock: Timer4 Stopped
; 0000 00C2 // Mode: Normal top=OCR4C
; 0000 00C3 // OC4A output: OC4A=Disc. /OC4A=Disc.
; 0000 00C4 // OC4B output: OC4B=Disc. /OC4B=Disc.
; 0000 00C5 // OC4D output: OC4D=Disc. /OC4D=Disc.
; 0000 00C6 // Fault Protection: Off
; 0000 00C7 // Fault Protection Noise Canceler: Off
; 0000 00C8 // Fault Protection triggered on Falling Edge
; 0000 00C9 // Timer4 Overflow Interrupt: Off
; 0000 00CA // Compare A Match Interrupt: Off
; 0000 00CB // Compare B Match Interrupt: Off
; 0000 00CC // Compare D Match Interrupt: Off
; 0000 00CD // Fault Protection Interrupt: Off
; 0000 00CE // Dead Time Prescaler: 1
; 0000 00CF // Dead Time Rising Edge: 0.000 us
; 0000 00D0 // Dead Time Falling Edge: 0.000 us
; 0000 00D1 
; 0000 00D2 // Set Timer4 for synchronous operation
; 0000 00D3 PLLFRQ&=(1<<PINMUX) | (1<<PLLUSB) | (0<<PLLTM1) | (0<<PLLTM0) | (1<<PDIV3) | (1<<PDIV2) | (1<<PDIV1) | (1<<PDIV0);
	IN   R30,0x32
	ANDI R30,LOW(0xCF)
	OUT  0x32,R30
; 0000 00D4 
; 0000 00D5 TCCR4A=(0<<COM4A1) | (0<<COM4A0) | (0<<COM4B1) | (0<<COM4B0) | (0<<FOC4A) | (0<<FOC4B) | (0<<PWM4A) | (0<<PWM4B);
	LDI  R30,LOW(0)
	STS  192,R30
; 0000 00D6 TCCR4B=(0<<PWM4X) | (0<<PSR4) | (0<<DTPS41) | (0<<DTPS40) | (0<<CS43) | (0<<CS42) | (0<<CS41) | (0<<CS40);
	STS  193,R30
; 0000 00D7 TCCR4C=(0<<COM4A1S) | (0<<COM4A0S) | (0<<COM4B1S) | (0<<COM4B0S) | (0<<COM4D1) | (0<<COM4D0) | (0<<FOC4D) | (0<<PWM4D);
	STS  194,R30
; 0000 00D8 TCCR4D=(0<<FPIE4) | (0<<FPEN4) | (0<<FPNC4) | (0<<FPES4) | (0<<FPAC4) | (0<<FPF4) | (0<<WGM41) | (0<<WGM40);
	STS  195,R30
; 0000 00D9 TCCR4E=(0<<TLOCK4) | (0<<ENHC4) | (0<<OC4OE5) | (0<<OC4OE4) | (0<<OC4OE3) | (0<<OC4OE2) | (0<<OC4OE1) | (0<<OC4OE0);
	STS  196,R30
; 0000 00DA TC4H=0x00;
	CALL SUBOPT_0x2
; 0000 00DB TCNT4=0x00;
	STS  190,R30
; 0000 00DC TC4H=0x00;
	CALL SUBOPT_0x2
; 0000 00DD OCR4A=0x00;
	STS  207,R30
; 0000 00DE TC4H=0x00;
	CALL SUBOPT_0x2
; 0000 00DF OCR4B=0x00;
	STS  208,R30
; 0000 00E0 TC4H=0x00;
	CALL SUBOPT_0x2
; 0000 00E1 OCR4C=0x00;
	STS  209,R30
; 0000 00E2 TC4H=0x00;
	CALL SUBOPT_0x2
; 0000 00E3 OCR4D=0x00;
	STS  210,R30
; 0000 00E4 DT4=0x00;
	LDI  R30,LOW(0)
	STS  212,R30
; 0000 00E5 
; 0000 00E6 // Timer/Counter 0 Interrupt(s) initialization
; 0000 00E7 TIMSK0=(0<<OCIE0B) | (0<<OCIE0A) | (0<<TOIE0);
	STS  110,R30
; 0000 00E8 
; 0000 00E9 // Timer/Counter 1 Interrupt(s) initialization
; 0000 00EA TIMSK1=(0<<ICIE1) | (0<<OCIE1C) | (0<<OCIE1B) | (0<<OCIE1A) | (0<<TOIE1);
	STS  111,R30
; 0000 00EB 
; 0000 00EC // Timer/Counter 3 Interrupt(s) initialization
; 0000 00ED TIMSK3=(0<<ICIE3) | (0<<OCIE3C) | (0<<OCIE3B) | (0<<OCIE3A) | (0<<TOIE3);
	STS  113,R30
; 0000 00EE 
; 0000 00EF // Timer/Counter 4 Interrupt(s) initialization
; 0000 00F0 TIMSK4=(0<<OCIE4D) | (0<<OCIE4A) | (0<<OCIE4B) | (0<<TOIE4);
	STS  114,R30
; 0000 00F1 
; 0000 00F2 // USB Controller initialization in device mode
; 0000 00F3 // Note: This function also initializes the PLL
; 0000 00F4 usb_init_device(&usb_config);
	LDI  R26,LOW(_usb_config*2)
	LDI  R27,HIGH(_usb_config*2)
	RCALL _usb_init_device
; 0000 00F5 
; 0000 00F6 // Global enable interrupts
; 0000 00F7 #asm("sei")
	sei
; 0000 00F8 
; 0000 00F9 // Wait for the USB device to be enumerated by the host
; 0000 00FA while (!usb_enumerated);
_0x19:
	LDS  R30,_usb_enumerated
	CPI  R30,0
	BREQ _0x19
; 0000 00FB 
; 0000 00FC // Wait 1.5 seconds for the operating system to
; 0000 00FD // load any drivers needed by the USB device
; 0000 00FE delay_ms(1500);
	LDI  R26,LOW(1500)
	LDI  R27,HIGH(1500)
	CALL _delay_ms
; 0000 00FF     if(JP_TM==0)
	SBIC 0x9,1
	RJMP _0x1C
; 0000 0100     {
; 0000 0101      tim = 600;   //60
	LDI  R30,LOW(600)
	LDI  R31,HIGH(600)
	RJMP _0x22
; 0000 0102     }else{ tim = 300; }  //30
_0x1C:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
_0x22:
	__PUTW1R 5,6
; 0000 0103 while (1)
_0x1E:
; 0000 0104       {
; 0000 0105        pr();
	RCALL _pr
; 0000 0106 
; 0000 0107       }
	RJMP _0x1E
; 0000 0108 }
_0x21:
	RJMP _0x21
; .FEND
;/*******************************************************
;USB library initialization created by the
;CodeWizardAVR V3.12 Advanced
;Automatic Program Generator
; Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project:
;*******************************************************/
;
;#include "usb_init.h"
;
;// USB device descriptors
;
;flash USB_DEVICE_DESCRIPTOR_t usb_device_descriptor =
;{
;.bLength=sizeof(USB_DEVICE_DESCRIPTOR_t),
;.bDescriptorType=USB_DESCRIPTOR_TYPE_DEVICE,
;.bcdUSB=USB_SPEC,
;.bDeviceClass=USB_CLASS_NONE,
;.bDeviceSubClass=USB_SUBCLASS_NONE,
;.bDeviceProtocol=USB_PROTOCOL_NONE,
;.bMaxPacketSize0=USB_ENDPOINT0_SIZE,
;.idVendor=USB_VENDOR_ID,
;.idProduct=USB_PRODUCT_ID,
;.bcdDevice=USB_DEVICE_RELEASE,
;.iManufacturer=1,
;.iProduct=2,
;.iSerialNumber=3,
;.bNumConfigurations=1
;};
;
;// HID Keyboard report descriptor
;flash unsigned char hid_keyboard_report_descriptor[]=
;{
;HID_RD_USAGE_PAGE(8,1), // Generic desktop
;HID_RD_USAGE(8,6), // Keyboard
;HID_RD_COLLECTION(8,HID_RD_COLLECTION_APPLICATION),
;HID_RD_REPORT_SIZE(8,1),
;HID_RD_REPORT_COUNT(8,8),
;HID_RD_USAGE_PAGE(8,7), // Key codes
;HID_RD_USAGE_MIN(8,0xE0),
;HID_RD_USAGE_MAX(8,0xE7),
;HID_RD_LOGICAL_MIN(8,0),
;HID_RD_LOGICAL_MAX(8,1),
;HID_RD_INPUT(8,HID_RD_DATA_F | HID_RD_VARIABLE_F | HID_RD_ABSOLUTE_F),
;HID_RD_REPORT_COUNT(8,1),
;HID_RD_REPORT_SIZE(8,8),
;HID_RD_INPUT(8,HID_RD_CONSTANT_F | HID_RD_VARIABLE_F),
;HID_RD_REPORT_COUNT(8,5),
;HID_RD_REPORT_SIZE(8,1),
;HID_RD_USAGE_PAGE(8,8), // Leds
;HID_RD_USAGE_MIN(8,1),
;HID_RD_USAGE_MAX(8,5),
;HID_RD_OUTPUT(8,HID_RD_DATA_F | HID_RD_VARIABLE_F | HID_RD_ABSOLUTE_F | HID_RD_NON_VOLATILE_F),
;HID_RD_REPORT_COUNT(8,1),
;HID_RD_REPORT_SIZE(8,3),
;HID_RD_OUTPUT(8,HID_RD_CONSTANT_F | HID_RD_VARIABLE_F),
;HID_RD_REPORT_COUNT(8,6),
;HID_RD_REPORT_SIZE(8,8),
;HID_RD_LOGICAL_MIN(8,0),
;HID_RD_LOGICAL_MAX(8,0xFF),
;HID_RD_USAGE_PAGE(8,7), // Key codes
;HID_RD_USAGE_MIN(8,0),
;HID_RD_USAGE_MAX(8,0xFF),
;HID_RD_INPUT(8,HID_RD_DATA_F | HID_RD_ARRAY_F),
;HID_RD_END_COLLECTION(0)
;};
;
;// Strings descriptors
;flash unsigned short usb_string0[]=
;{
;2+sizeof(short)+ // bLength
;(USB_DESCRIPTOR_TYPE_STRING<<8), // bDescriptorType
;USB_LANG_ID_US_ENGLISH // wLangID
;};
;
;flash unsigned short usb_string1[]=
;{
;2+USB_STR_MANUFACTURER_CHARS*2+ // bLength
;(USB_DESCRIPTOR_TYPE_STRING<<8), // bDescriptorType
;USB_STR_MANUFACTURER // bString
;};
;
;flash unsigned short usb_string2[]=
;{
;2+USB_STR_PRODUCT_CHARS*2+ // bLength
;(USB_DESCRIPTOR_TYPE_STRING<<8), // bDescriptorType
;USB_STR_PRODUCT // bString
;};
;
;flash unsigned short usb_string3[]=
;{
;2+USB_STR_SERIAL_NUMBER_CHARS*2+ // bLength
;(USB_DESCRIPTOR_TYPE_STRING<<8), // bDescriptorType
;USB_STR_SERIAL_NUMBER // bString
;};
;
;// USB configuration descriptor
;flash struct
;{
;// Configuration Descriptor
;USB_CONFIG_DESCRIPTOR_t config_descriptor;
;
;// Interface 0 - HID Keyboard
;USB_INTERFACE_DESCRIPTOR_t interface0_descriptor;
;USB_HID_INTERFACE_DESCRIPTOR_t interface0_hid_descriptor;
;USB_ENDPOINT_DESCRIPTOR_t interface0_in_endpoint_descriptor;
;} usb_config_descriptor=
;{
;// Configuration Descriptor
;{
;.bLength=sizeof(USB_CONFIG_DESCRIPTOR_t),
;.bDescriptorType=USB_DESCRIPTOR_TYPE_CONFIGURATION,
;.wTotalLength=sizeof(usb_config_descriptor),
;.bNumInterfaces=1,
;.bConfigurationValue=1,
;.iConfiguration=USB_STRING_NONE,
;.bmAttributes=USB_ATTR_COMPAT1 | USB_ATTR_SELF_POWERED,
;.bMaxPower=100/2
;},
;
;// Interface 0 - HID Keyboard
;// Descriptor
;{
;.bLength=sizeof(USB_INTERFACE_DESCRIPTOR_t),
;.bDescriptorType=USB_DESCRIPTOR_TYPE_INTERFACE,
;.bInterfaceNumber=0,
;.bAlternateSetting=USB_ALTERNATE_SETTING_NONE,
;.bNumEndpoints=1,
;.bInterfaceClass=USB_CLASS_HID,
;.bInterfaceSubClass=USB_SUBCLASS_HID_BOOT,
;.bInterfaceProtocol=USB_PROTOCOL_KEYBOARD,
;.iInterface=USB_STRING_NONE
;},
;
;// HID Interface Descriptor - Keyboard
;{
;.bLength=sizeof(USB_HID_INTERFACE_DESCRIPTOR_t),
;.bDescriptorType=USB_DESCRIPTOR_TYPE_HID_INTERFACE,
;.bcdHID=USB_HID_SPEC,
;.bCountryCode=0,
;.bNumDescriptors=1,
;.bReportDescriptorType=USB_DESCRIPTOR_TYPE_REPORT,
;.wDescriptorLength=sizeof(hid_keyboard_report_descriptor)
;},
;
;// IN Endpoint Descriptor
;{
;.bLength=sizeof(USB_ENDPOINT_DESCRIPTOR_t),
;.bDescriptorType=USB_DESCRIPTOR_TYPE_ENDPOINT,
;.bEndpointAddress=USB_INTERFACE0_IN_EP | USB_ENDPOINT_DIR_IN,
;.bmAttributes=USB_TRANSFER_INTERRUPT | USB_EP_ATTR_NO_SYNC | USB_EP_USAGE_DATA,
;.wMaxPacketSize=USB_INTERFACE0_IN_EP_SIZE,
;.bInterval=USB_INTERFACE0_IN_EP_SERVICE_INTERVAL
;}
;};
;
;// This table defines which descriptor data is sent for each specific
;// request from the host (in wValue and wIndex)
;flash USB_DESCRIPTOR_LIST_t usb_descriptor_list[]=
;{
;{0,USB_DESCRIPTOR_TYPE_DEVICE,0,&usb_device_descriptor,sizeof(usb_device_descriptor)},
;{0,USB_DESCRIPTOR_TYPE_CONFIGURATION,0,&usb_config_descriptor,sizeof(usb_config_descriptor)},
;{0,USB_DESCRIPTOR_TYPE_HID_INTERFACE,0 /* Interface # */,&usb_config_descriptor.interface0_hid_descriptor,sizeof(USB_HID ...
;{0,USB_DESCRIPTOR_TYPE_REPORT,0 /* Interface # */,hid_keyboard_report_descriptor,sizeof(hid_keyboard_report_descriptor)} ...
;{0,USB_DESCRIPTOR_TYPE_STRING,0,&usb_string0,sizeof(usb_string0)},
;{1,USB_DESCRIPTOR_TYPE_STRING,USB_LANG_ID_US_ENGLISH,&usb_string1,sizeof(usb_string1)},
;{2,USB_DESCRIPTOR_TYPE_STRING,USB_LANG_ID_US_ENGLISH,&usb_string2,sizeof(usb_string2)},
;{3,USB_DESCRIPTOR_TYPE_STRING,USB_LANG_ID_US_ENGLISH,&usb_string3,sizeof(usb_string3)}
;};
;
;// USB device configuration
;flash USB_CONFIG_t usb_config=
;{
;// Interface(s) configuration
;.interface=
;{
;// Interface 0
;{
;.bInterfaceClass=USB_CLASS_HID,
;.bInterfaceProtocol=USB_PROTOCOL_KEYBOARD,
;.report_data=&usb_keyboard,
;.report_size=sizeof(USB_KEYBOARD_t),
;// IN endpoint configuration
;.in={.ep=USB_INTERFACE0_IN_EP,.type=USB_TRANSFER_INTERRUPT,.size=USB_INTERFACE0_IN_EP_SIZE}
;}
;},
;.pdescriptor_list=usb_descriptor_list,
;.descriptor_list_items=sizeof(usb_descriptor_list)/sizeof(USB_DESCRIPTOR_LIST_t),
;.timeout={.tx=USB_TX_TIMEOUT,.rx=USB_RX_TIMEOUT}
;};
;
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
     .EQU __sm_adc_noise_red=0x02 // 26022010_1
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif

	.CSEG
_get_fifo_size_G100:
; .FSTART _get_fifo_size_G100
	LDS  R30,237
	SWAP R30
	ANDI R30,0xF
	LDI  R26,LOW(8)
	CALL __LSLB12
	RET
; .FEND
_usb_init_endpoint_G100:
; .FSTART _usb_init_endpoint_G100
	ST   -Y,R26
	CALL __SAVELOCR4
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LPM  R30,Z
	ANDI R30,LOW(0xF)
	SUBI R30,LOW(1)
	MOV  R17,R30
	CPI  R17,255
	BREQ _0x2000004
	CPI  R17,4
	BRSH _0x2000005
	LDI  R26,LOW(3)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_ep_reg_G100)
	SBCI R31,HIGH(-_ep_reg_G100)
	MOVW R18,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,1
	LPM  R17,Z
	CPI  R17,0
	BREQ _0x2000004
	CPI  R17,129
	BRSH _0x2000007
	MOVW R26,R18
	LDI  R30,LOW(1)
	ST   X,R30
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	LPM  R30,Z
	SWAP R30
	ANDI R30,LOW(0x3)
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	LSL  R30
	LDD  R26,Y+4
	OR   R30,R26
	__PUTB1RNS 18,1
	CPI  R17,65
	BRLO _0x2000008
	LDI  R17,LOW(64)
	RJMP _0x2000009
_0x2000008:
	CPI  R17,33
	BRLO _0x200000A
	LDI  R17,LOW(48)
	RJMP _0x200000B
_0x200000A:
	CPI  R17,17
	BRLO _0x200000C
	LDI  R17,LOW(32)
	RJMP _0x200000D
_0x200000C:
	CPI  R17,9
	BRLO _0x200000E
	LDI  R17,LOW(16)
	RJMP _0x200000F
_0x200000E:
	LDI  R17,LOW(0)
_0x200000F:
_0x200000D:
_0x200000B:
_0x2000009:
	MOV  R30,R17
	ORI  R30,LOW(0x6)
	__PUTB1RNS 18,2
_0x2000004:
	LDI  R30,LOW(1)
	RJMP _0x2060005
_0x2000007:
_0x2000005:
	LDI  R30,LOW(0)
_0x2060005:
	CALL __LOADLOCR4
	ADIW R28,7
	RET
; .FEND
_usb_init_device:
; .FSTART _usb_init_device
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR6
	LDI  R30,LOW(1)
	STS  215,R30
	LDI  R30,LOW(160)
	STS  216,R30
	LDI  R30,LOW(74)
	OUT  0x32,R30
	LDI  R30,LOW(0)
	OUT  0x29,R30
	LDI  R30,LOW(18)
	OUT  0x29,R30
_0x2000010:
	IN   R30,0x29
	SBRS R30,0
	RJMP _0x2000010
	LDI  R30,LOW(0)
	STS  218,R30
	LDI  R30,LOW(144)
	STS  216,R30
	LDI  R30,LOW(0)
	STS  224,R30
	STS  225,R30
	LDI  R30,LOW(12)
	STS  226,R30
	CALL SUBOPT_0x3
	CBI  0x1E,0
	CBI  0x1E,1
	LDI  R30,LOW(0)
	STS  _usb_enumerated,R30
	LDI  R30,LOW(_ep_reg_G100)
	LDI  R31,HIGH(_ep_reg_G100)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(12)
	LDI  R27,0
	CALL _memset
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,0
	BRNE _0x2000017
	LDI  R30,LOW(0)
	RJMP _0x2060004
_0x2000017:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,18
	CALL __GETW1PF
	SBIW R30,0
	BRNE _0x2000018
	LDI  R30,LOW(0)
	RJMP _0x2060004
_0x2000018:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,20
	LPM  R30,Z
	CPI  R30,0
	BRNE _0x2000019
	LDI  R30,LOW(0)
	RJMP _0x2060004
_0x2000019:
	__GETWRS 20,21,6
	LDI  R17,LOW(0)
_0x200001B:
	CPI  R17,2
	BRSH _0x200001C
	MOVW R30,R20
	LPM  R16,Z
	CPI  R16,0
	BREQ _0x200001D
	ADIW R30,5
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _usb_init_endpoint_G100
	CPI  R30,0
	BREQ _0x200001F
	MOVW R30,R20
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _usb_init_endpoint_G100
	CPI  R30,0
	BRNE _0x200001E
_0x200001F:
	LDI  R30,LOW(0)
	RJMP _0x2060004
_0x200001E:
	MOVW R30,R20
	ADIW R30,2
	CALL __GETW1PF
	MOVW R18,R30
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x2000021
	ST   -Y,R19
	ST   -Y,R18
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOVW R30,R20
	ADIW R30,4
	LPM  R26,Z
	LDI  R27,0
	CALL _memset
_0x2000021:
	CPI  R16,3
	BRNE _0x2000022
	MOVW R30,R20
	ADIW R30,1
	LPM  R30,Z
	CPI  R30,LOW(0x1)
	BRNE _0x2000025
	CPI  R17,0
	BRNE _0x2000027
	CBI  0x1E,2
	RJMP _0x2000028
_0x2000027:
	SBI  0x1E,2
_0x2000028:
	MOVW R30,R20
	ADIW R30,5
	LPM  R30,Z
	ANDI R30,LOW(0xF)
	STS  _usb_keyboard_ep,R30
_0x2000025:
_0x2000022:
_0x200001D:
	__ADDWRN 20,21,9
	SUBI R17,-1
	RJMP _0x200001B
_0x200001C:
	LDI  R30,LOW(0)
	STS  _usb_keyboard_leds,R30
	LDI  R30,LOW(125)
	STS  _usb_keyboard_idle_interval,R30
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	CALL SUBOPT_0x4
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,21
	LDI  R26,LOW(_usb_timeout)
	LDI  R27,HIGH(_usb_timeout)
	LDI  R24,2
	CALL __COPYMFL
	__GETWRS 7,8,6
	SBI  0x1E,1
	LDI  R30,LOW(1)
_0x2060004:
	CALL __LOADLOCR6
	ADIW R28,8
	RET
; .FEND
_usb_getconfig:
; .FSTART _usb_getconfig
	CLR  R0
	CP   R0,R7
	CPC  R0,R8
	BREQ _0x200002C
	SBIC 0x1E,1
	RJMP _0x200002B
_0x200002C:
	LDI  R30,LOW(128)
	RET
_0x200002B:
	LDS  R30,_usb_enumerated
	CPI  R30,0
	BRNE _0x200002E
	LDI  R30,LOW(129)
	RET
_0x200002E:
	LDI  R30,LOW(0)
	RET
; .FEND
_usb_select_in_ep_G100:
; .FSTART _usb_select_in_ep_G100
	ST   -Y,R17
	RCALL _usb_getconfig
	MOV  R17,R30
	CPI  R30,0
	BRNE _0x200002F
	cli
	LDI  R30,0
	SBIC 0x1E,0
	LDI  R30,1
	LDI  R26,LOW(9)
	MUL  R30,R26
	MOVW R30,R0
	CALL SUBOPT_0x5
	CPI  R30,0
	BRNE _0x2000030
	LDI  R17,LOW(128)
_0x2000030:
_0x200002F:
	RJMP _0x2060003
; .FEND
_usb_tx_timeout_G100:
; .FSTART _usb_tx_timeout_G100
	ST   -Y,R17
	RCALL _usb_select_in_ep_G100
	MOV  R17,R30
	CPI  R30,0
	BRNE _0x2000033
	CALL SUBOPT_0x6
	LD   R30,Z
	ANDI R30,LOW(0x2)
	BREQ _0x2000034
	LDS  R30,232
	ANDI R30,LOW(0x20)
	BREQ _0x2000035
	CALL SUBOPT_0x6
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RJMP _0x2000036
_0x2000035:
	LDI  R17,LOW(131)
_0x2000036:
_0x2000034:
_0x2000033:
_0x2060003:
	MOV  R30,R17
	LD   R17,Y+
	RET
; .FEND
_usb_fifo_ready_tx_G100:
; .FSTART _usb_fifo_ready_tx_G100
	ST   -Y,R26
	CALL __SAVELOCR4
	LDS  R30,233
	MOV  R17,R30
	LDS  R16,_usb_timeout
	LDS  R30,228
	MOV  R19,R30
_0x2000037:
	LDS  R30,232
	ANDI R30,LOW(0x20)
	BRNE _0x2000039
	LDD  R30,Y+4
	OUT  0x3F,R30
	nop
	IN   R30,0x3F
	STD  Y+4,R30
	cli
	STS  233,R17
	LDS  R30,228
	CP   R30,R19
	BREQ _0x200003A
	LDS  R19,228
	SUBI R16,LOW(1)
	BRNE _0x200003B
	CALL SUBOPT_0x6
	LDI  R26,LOW(2)
	STD  Z+0,R26
	LDI  R30,LOW(131)
	CALL __LOADLOCR4
	JMP  _0x2060001
_0x200003B:
_0x200003A:
	LDS  R30,_usb_enumerated
	CPI  R30,0
	BRNE _0x200003C
	LDI  R30,LOW(129)
	CALL __LOADLOCR4
	JMP  _0x2060001
_0x200003C:
	RJMP _0x2000037
_0x2000039:
	LDI  R30,LOW(0)
	CALL __LOADLOCR4
	JMP  _0x2060001
; .FEND
_usb_tx_fifo_G100:
; .FSTART _usb_tx_fifo_G100
	LDS  R30,232
	ANDI R30,LOW(0x20)
	BRNE _0x200003D
	CALL SUBOPT_0x7
_0x200003D:
	CALL SUBOPT_0x6
	LDI  R26,LOW(1)
	STD  Z+0,R26
	RET
; .FEND
_usb_putbuf:
; .FSTART _usb_putbuf
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR6
	IN   R18,63
	RCALL _usb_tx_timeout_G100
	MOV  R19,R30
	CPI  R30,0
	BRNE _0x2000040
	__GETWRS 16,17,8
	RCALL _get_fifo_size_G100
	MOV  R20,R30
_0x2000041:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,0
	BREQ _0x2000043
	MOV  R26,R18
	RCALL _usb_fifo_ready_tx_G100
	MOV  R19,R30
	CPI  R30,0
	BRNE _0x2000043
	LDS  R26,242
	MOV  R30,R20
	SUB  R30,R26
	MOV  R21,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	MOV  R26,R21
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x2000045
	LDD  R21,Y+6
_0x2000045:
	MOV  R30,R21
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R31,0
	SUB  R26,R30
	SBC  R27,R31
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000046:
	MOV  R30,R21
	SUBI R21,1
	CPI  R30,0
	BREQ _0x2000048
	CALL SUBOPT_0x8
	STS  241,R30
	RJMP _0x2000046
_0x2000048:
	RCALL _usb_tx_fifo_G100
	RJMP _0x2000041
_0x2000043:
_0x2000040:
	OUT  0x3F,R18
	MOV  R30,R19
	CALL __LOADLOCR6
	ADIW R28,10
	RET
; .FEND
_usb_general_isr:
; .FSTART _usb_general_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	CALL __SAVELOCR4
	LDS  R17,225
	LDI  R30,LOW(0)
	STS  225,R30
	SBRS R17,3
	RJMP _0x2000081
	LDI  R30,LOW(0)
	STS  233,R30
	LDI  R30,LOW(1)
	STS  235,R30
	LDI  R30,LOW(0)
	STS  236,R30
	LDI  R30,LOW(34)
	STS  237,R30
	LDI  R30,LOW(8)
	STS  240,R30
	LDI  R30,LOW(0)
	STS  _usb_enumerated,R30
	STS  _usb_keyboard_leds,R30
_0x2000081:
	SBRS R17,2
	RJMP _0x2000083
	LDS  R30,_usb_enumerated
	CPI  R30,0
	BRNE _0x2000084
_0x2000083:
	RJMP _0x2000082
_0x2000084:
	LDI  R17,LOW(0)
_0x2000085:
	CPI  R17,2
	BRSH _0x2000087
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_usb_tx_flags_G100)
	SBCI R31,HIGH(-_usb_tx_flags_G100)
	LD   R30,Z
	ANDI R30,LOW(0x1)
	BREQ _0x2000088
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_usb_tx_flags_G100)
	SBCI R31,HIGH(-_usb_tx_flags_G100)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	LDI  R26,LOW(9)
	MUL  R17,R26
	MOVW R30,R0
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	RJMP _0x2000087
_0x2000088:
	SUBI R17,-LOW(1)
	RJMP _0x2000085
_0x2000087:
	LDS  R30,_usb_keyboard_idle_interval
	CPI  R30,0
	BREQ _0x2000089
	LDS  R30,_usb_keyboard_ep
	STS  233,R30
	LDS  R30,232
	ANDI R30,LOW(0x20)
	BREQ _0x200008A
	LDI  R26,LOW(_usb_keyboard_idle_timeout)
	LDI  R27,HIGH(_usb_keyboard_idle_timeout)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,0
	BRNE _0x200008B
	CALL SUBOPT_0x9
	__POINTWRM 18,19,_usb_keyboard
	LDI  R17,LOW(8)
_0x200008D:
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R30,X
	STS  241,R30
	SUBI R17,LOW(1)
	BRNE _0x200008D
	CALL SUBOPT_0x7
_0x200008B:
_0x200008A:
_0x2000089:
_0x2000082:
	CALL __LOADLOCR4
	ADIW R28,4
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND
_usb_endpoint_isr:
; .FSTART _usb_endpoint_isr
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	SBIW R28,12
	CALL __SAVELOCR6
	LDI  R30,LOW(0)
	STS  233,R30
	LDS  R30,232
	ANDI R30,LOW(0x8)
	BRNE PC+2
	RJMP _0x200008F
	LDI  R19,LOW(8)
	MOVW R30,R28
	ADIW R30,6
	MOVW R16,R30
_0x2000091:
	LDS  R30,241
	MOVW R26,R16
	ST   X,R30
	__ADDWRN 16,17,1
	SUBI R19,LOW(1)
	BRNE _0x2000091
	LDI  R30,LOW(242)
	STS  232,R30
	LDD  R26,Y+7
	CPI  R26,LOW(0x6)
	BREQ PC+2
	RJMP _0x2000093
	__GETW1R 7,8
	ADIW R30,18
	CALL __GETW1PF
	STD  Y+16,R30
	STD  Y+16+1,R31
	__GETW1R 7,8
	ADIW R30,20
	LPM  R18,Z
	LDI  R19,LOW(0)
_0x2000094:
	PUSH R19
	SUBI R19,-1
	MOV  R30,R18
	POP  R26
	CP   R26,R30
	BRLO _0x2000097
	RJMP _0x2000098
_0x2000097:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	CALL __GETD2PF
	__GETD1S 8
	CALL __CPD12
	BRNE _0x2000099
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,4
	CALL __GETW1PF
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,6
	LPM  R21,Z
	RJMP _0x2000096
_0x2000099:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,7
	STD  Y+16,R30
	STD  Y+16+1,R31
	RJMP _0x2000094
_0x2000096:
	LDD  R20,Y+12
	MOV  R30,R21
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x200009A
	MOV  R20,R21
_0x200009A:
_0x200009B:
_0x200009D:
_0x20000A0:
	LDS  R18,232
	MOV  R30,R18
	ANDI R30,LOW(0x5)
	BREQ _0x20000A0
	SBRC R18,2
	RJMP _0x20000F6
	MOV  R18,R20
	CPI  R18,32
	BRLO _0x20000A3
	LDI  R18,LOW(32)
_0x20000A3:
	MOV  R19,R18
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SBIW R30,0
	BREQ _0x20000A4
_0x20000A5:
	MOV  R30,R19
	SUBI R19,1
	CPI  R30,0
	BREQ _0x20000A7
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	LPM  R30,Z
	STS  241,R30
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADIW R30,1
	STD  Y+14,R30
	STD  Y+14+1,R31
	RJMP _0x20000A5
_0x20000A7:
	RJMP _0x20000A8
_0x20000A4:
_0x20000A9:
	MOV  R30,R19
	SUBI R19,1
	CPI  R30,0
	BREQ _0x20000AB
	LDI  R30,LOW(0)
	STS  241,R30
	RJMP _0x20000A9
_0x20000AB:
_0x20000A8:
	SUB  R20,R18
	LDI  R30,LOW(254)
	STS  232,R30
	CPI  R20,0
	BRNE _0x20000AC
	CPI  R18,32
	BRNE _0x200009E
_0x20000AC:
	RJMP _0x200009D
_0x200009E:
	RJMP _0x20000F6
_0x2000093:
	LDD  R26,Y+7
	CPI  R26,LOW(0x5)
	BRNE _0x20000AE
	LDI  R30,LOW(254)
	STS  232,R30
_0x20000AF:
	LDS  R30,232
	ANDI R30,LOW(0x1)
	BREQ _0x20000AF
	LDD  R30,Y+8
	ORI  R30,0x80
	STS  227,R30
	RJMP _0x20000F6
_0x20000AE:
	LDD  R26,Y+7
	CPI  R26,LOW(0x1)
	BREQ _0x20000B3
	CPI  R26,LOW(0x3)
	BRNE _0x20000B2
_0x20000B3:
	LDD  R26,Y+6
	CPI  R26,LOW(0x2)
	BRNE _0x20000B5
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	SBIW R30,0
	BRNE _0x20000B6
	LDD  R30,Y+10
	ANDI R30,0x7F
	MOV  R18,R30
	CPI  R18,1
	BRLO _0x20000B8
	CPI  R18,5
	BRLO _0x20000B9
_0x20000B8:
	RJMP _0x20000B7
_0x20000B9:
	LDI  R30,LOW(254)
	STS  232,R30
	STS  233,R18
	LDD  R26,Y+7
	CPI  R26,LOW(0x3)
	BRNE _0x20000BA
	RJMP _0x2000098
_0x20000BA:
	LDI  R30,LOW(25)
	STS  235,R30
	MOV  R30,R18
	LDI  R26,LOW(1)
	CALL __LSLB12
	RJMP _0x20000F5
_0x20000B7:
_0x20000B6:
_0x20000B5:
_0x20000B2:
	LDD  R26,Y+7
	CPI  R26,LOW(0x9)
	BRNE _0x20000BD
	LDD  R26,Y+6
	CPI  R26,LOW(0x0)
	BREQ _0x20000BE
_0x20000BD:
	RJMP _0x20000BC
_0x20000BE:
	LDD  R30,Y+8
	STS  _usb_enumerated,R30
	CALL SUBOPT_0x3
	LDI  R30,LOW(0)
	STS  _usb_keyboard_leds,R30
	__POINTWRM 16,17,_ep_reg_G100
	LDI  R30,LOW(254)
	STS  232,R30
	LDI  R19,LOW(1)
_0x20000C0:
	CPI  R19,5
	BRSH _0x20000C1
	STS  233,R19
	CALL SUBOPT_0x8
	STS  235,R30
	CALL SUBOPT_0x8
	STS  236,R30
	CALL SUBOPT_0x8
	STS  237,R30
	SUBI R19,-1
	RJMP _0x20000C0
_0x20000C1:
	LDI  R30,LOW(30)
_0x20000F5:
	STS  234,R30
	LDI  R30,LOW(0)
	STS  234,R30
	RJMP _0x20000F6
_0x20000BC:
	LDD  R26,Y+7
	CPI  R26,LOW(0x8)
	BRNE _0x20000C3
	LDD  R26,Y+6
	CPI  R26,LOW(0x80)
	BREQ _0x20000C4
_0x20000C3:
	RJMP _0x20000C2
_0x20000C4:
	__POINTWRM 16,17,_usb_enumerated
_0x20000C5:
	LDI  R18,LOW(1)
_0x20000C6:
_0x20000C7:
	LDS  R30,232
	ANDI R30,LOW(0x1)
	BREQ _0x20000C7
_0x20000CB:
	CALL SUBOPT_0x8
	STS  241,R30
	SUBI R18,LOW(1)
	BRNE _0x20000CB
	RJMP _0x20000CD
_0x20000C2:
	LDD  R30,Y+7
	CPI  R30,0
	BRNE _0x20000CE
	LDI  R18,LOW(0)
	LDD  R26,Y+6
	CPI  R26,LOW(0x82)
	BRNE _0x20000CF
	LDD  R30,Y+10
	STS  233,R30
	LDS  R30,235
	ANDI R30,LOW(0x20)
	BREQ _0x20000D0
	LDI  R18,LOW(1)
_0x20000D0:
	LDI  R30,LOW(0)
	STS  233,R30
_0x20000CF:
_0x20000D1:
	LDS  R30,232
	ANDI R30,LOW(0x1)
	BREQ _0x20000D1
	STS  241,R18
	LDI  R30,LOW(0)
	STS  241,R30
_0x20000CD:
	LDI  R30,LOW(254)
	STS  232,R30
	RJMP _0x20000F6
_0x20000CE:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,2
	BRLO _0x20000D4
	RJMP _0x2000098
_0x20000D4:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDI  R30,LOW(9)
	CALL __MULB1W2U
	ADD  R30,R7
	ADC  R31,R8
	STD  Y+16,R30
	STD  Y+16+1,R31
	LPM  R21,Z
	ADIW R30,1
	LPM  R18,Z
	LDD  R26,Y+6
	CPI  R26,LOW(0xA1)
	BRNE _0x20000D5
	CPI  R21,3
	BRNE _0x20000D6
	LDD  R26,Y+7
	CPI  R26,LOW(0x1)
	BRNE _0x20000D7
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,2
	CALL __GETW1PF
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x20000D8
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,4
	LPM  R18,Z
	RJMP _0x20000C6
_0x20000D8:
	LDI  R30,LOW(0)
	STD  Y+14,R30
	STD  Y+14+1,R30
	LDD  R20,Y+12
	LDD  R30,Y+13
	CPI  R30,0
	BREQ _0x20000D9
	LDI  R20,LOW(255)
_0x20000D9:
	RJMP _0x200009B
_0x20000D7:
	LDD  R26,Y+7
	CPI  R26,LOW(0x3)
	BRNE _0x20000DA
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUBI R30,LOW(-_usb_protocol_G100)
	SBCI R31,HIGH(-_usb_protocol_G100)
	MOVW R16,R30
	RJMP _0x20000C5
_0x20000DA:
	LDD  R26,Y+7
	CPI  R26,LOW(0x2)
	BRNE _0x20000DB
	CPI  R18,1
	BRNE _0x20000DC
	__POINTWRM 16,17,_usb_keyboard_idle_interval
	RJMP _0x20000C5
_0x20000DC:
_0x20000DB:
_0x20000D6:
_0x20000D5:
	LDD  R26,Y+6
	CPI  R26,LOW(0x21)
	BREQ PC+2
	RJMP _0x20000DD
	CPI  R21,3
	BREQ PC+2
	RJMP _0x20000DE
	LDD  R26,Y+7
	CPI  R26,LOW(0xB)
	BRNE _0x20000DF
	LDI  R30,LOW(254)
	STS  232,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUBI R30,LOW(-_usb_protocol_G100)
	SBCI R31,HIGH(-_usb_protocol_G100)
	LDD  R26,Y+8
	STD  Z+0,R26
	RJMP _0x20000F6
_0x20000DF:
	LDD  R26,Y+7
	CPI  R26,LOW(0x9)
	BRNE _0x20000E0
	CPI  R18,1
	BRNE _0x20000E1
_0x20000E2:
	LDS  R30,232
	ANDI R30,LOW(0x4)
	BREQ _0x20000E2
	LDS  R30,241
	STS  _usb_keyboard_leds,R30
	LDI  R30,LOW(251)
	STS  232,R30
	RJMP _0x20000CD
_0x20000E1:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,8
	LPM  R20,Z
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	MOV  R26,R20
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x20000E5
	LDD  R20,Y+12
_0x20000E5:
_0x20000E7:
	MOV  R18,R20
	CPI  R18,32
	BRLO _0x20000E9
	LDI  R18,LOW(32)
_0x20000E9:
_0x20000EA:
	LDS  R30,232
	ANDI R30,LOW(0x4)
	BREQ _0x20000EA
	MOV  R19,R18
_0x20000ED:
	MOV  R30,R19
	SUBI R19,1
	CPI  R30,0
	BREQ _0x20000EF
	LDS  R30,241
	RJMP _0x20000ED
_0x20000EF:
	SUB  R20,R18
	LDI  R30,LOW(251)
	STS  232,R30
	CPI  R20,0
	BRNE _0x20000E7
_0x20000F0:
	LDS  R30,232
	ANDI R30,LOW(0x1)
	BREQ _0x20000F0
	RJMP _0x20000CD
_0x20000E0:
	LDD  R26,Y+7
	CPI  R26,LOW(0xA)
	BRNE _0x20000F3
	CPI  R18,1
	BRNE _0x20000F4
	LDD  R30,Y+9
	STS  _usb_keyboard_idle_interval,R30
	CALL SUBOPT_0x9
	RJMP _0x20000CD
_0x20000F4:
_0x20000F3:
_0x20000DE:
_0x20000DD:
_0x200008F:
_0x2000098:
	LDI  R30,LOW(33)
	STS  235,R30
_0x20000F6:
	CALL __LOADLOCR6
	ADIW R28,18
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
; .FEND

	.CSEG
_usb_keyboard_sendkeys:
; .FSTART _usb_keyboard_sendkeys
	SBIC 0x1E,2
	RJMP _0x2020003
	CBI  0x1E,0
	RJMP _0x2020004
_0x2020003:
	SBI  0x1E,0
_0x2020004:
	LDI  R30,LOW(_usb_keyboard)
	LDI  R31,HIGH(_usb_keyboard)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(8)
	LDI  R27,0
	RCALL _usb_putbuf
	RET
; .FEND
_usb_keyboard_keypress:
; .FSTART _usb_keyboard_keypress
	ST   -Y,R26
	ST   -Y,R17
	LDI  R30,LOW(_usb_keyboard)
	LDI  R31,HIGH(_usb_keyboard)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(8)
	LDI  R27,0
	CALL _memset
	LDD  R30,Y+1
	STS  _usb_keyboard,R30
	LDD  R30,Y+2
	__PUTB1MN _usb_keyboard,2
	RCALL _usb_keyboard_sendkeys
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2020005
	RJMP _0x2060002
_0x2020005:
	LDI  R30,LOW(0)
	STS  _usb_keyboard,R30
	__PUTB1MN _usb_keyboard,2
	RCALL _usb_keyboard_sendkeys
_0x2060002:
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND

	.CSEG
_memset:
; .FSTART _memset
	ST   -Y,R27
	ST   -Y,R26
    ldd  r27,y+1
    ld   r26,y
    adiw r26,0
    breq memset1
    ldd  r31,y+4
    ldd  r30,y+3
    ldd  r22,y+2
memset0:
    st   z+,r22
    sbiw r26,1
    brne memset0
memset1:
    ldd  r30,y+3
    ldd  r31,y+4
_0x2060001:
	ADIW R28,5
	RET
; .FEND

	.DSEG
_usb_timeout:
	.BYTE 0x2
_usb_enumerated:
	.BYTE 0x1
_usb_keyboard:
	.BYTE 0x8
_usb_keyboard_leds:
	.BYTE 0x1
_usb_tx_flags_G100:
	.BYTE 0x2
_usb_protocol_G100:
	.BYTE 0x2
_usb_keyboard_ep:
	.BYTE 0x1
_usb_keyboard_idle_interval:
	.BYTE 0x1
_usb_keyboard_idle_timeout:
	.BYTE 0x2
_ep_reg_G100:
	.BYTE 0xC

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x0:
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _usb_keyboard_keypress

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	LDI  R26,LOW(100)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	STS  191,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	STS  _usb_tx_flags_G100,R30
	__PUTB1MN _usb_tx_flags_G100,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	STS  _usb_keyboard_idle_timeout,R30
	STS  _usb_keyboard_idle_timeout+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	ADD  R30,R7
	ADC  R31,R8
	ADIW R30,5
	LPM  R30,Z
	ANDI R30,LOW(0xF)
	STS  233,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6:
	LDI  R30,0
	SBIC 0x1E,0
	LDI  R30,1
	LDI  R31,0
	SUBI R30,LOW(-_usb_tx_flags_G100)
	SBCI R31,HIGH(-_usb_tx_flags_G100)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7:
	LDS  R30,232
	ANDI R30,LOW(0x7E)
	STS  232,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8:
	MOVW R26,R16
	__ADDWRN 16,17,1
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	LDS  R30,_usb_keyboard_idle_interval
	LDI  R31,0
	CALL __LSLW2
	RJMP SUBOPT_0x4


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETD2PF:
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z
	RET

__COPYMFL:
	CLR  R25
__COPYMF:
	PUSH R30
	PUSH R31
__COPYMF0:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __COPYMF0
	POP  R31
	POP  R30
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
